import flet as ft
from utils import AppView, Title
from ..functions import config


def Settings(page: ft.Page):
    settingsContainer = ft.ListView(
        expand=True,
    )
    settingsContainer.controls.append(ft.Text('General'))

    def _on_enable_change(e: ft.ControlEvent):
        if config.getint('apps', 'dhiraagu'):
            config.save('apps', 'dhiraagu', '0')
        else:
            config.save('apps', 'dhiraagu', '1')
        page.update()

    generalSettings = ft.Container(
        content=ft.Column(
            controls=[
                ft.Card(
                    content=ft.Container(
                        content=ft.Container(
                            ft.Switch(
                                label='     Enable this module',
                                on_change=_on_enable_change,
                                value=False,
                            ),
                        ),
                        padding=10,
                        on_click=None,
                    ),
                ),
            ],
        ),
    )
    if config.getint('apps', 'dhiraagu') == 1:
        generalSettings.content.controls[0].content.content.content.value = True
    settingsContainer.controls.append(
        generalSettings,
    )
    settingsContainer.controls.append(
        ft.Divider(),
    )

    # main settings
    settingsContainer.controls.append(ft.Text('Account'))
    loginForm = ft.Column()
    phoneInput = ft.Container(
        content=ft.TextField(
            config.get('dhiraagu', 'phone'),
            label='Phone',
            adaptive=True,
        ),
        padding=10,
    )
    loginForm.controls.append(phoneInput)

    otpInput = ft.Container(
        content=ft.TextField(
            config.get('dhiraagu', 'otp'),
            label='OTP',
            adaptive=True,
        ),
        padding=10,
    )
    loginForm.controls.append(otpInput)
    sendOTP = ft.CupertinoButton(
        content=ft.Text('SEND OTP'),
        opacity_on_click=0.3,
        on_click=lambda e: print('clicked!'),
    )

    if config.get('dhiraagu', 'token'):
        phoneInput.disabled = True
        otpInput.disabled = True
        sendOTP.disabled = True
        log = ft.CupertinoButton(
            content=ft.Text('LOG OUT'),
            opacity_on_click=0.3,
            on_click=lambda e: print('clicked!'),
        )
    else:
        log = ft.CupertinoButton(
            content=ft.Text('LOG IN'),
            opacity_on_click=0.3,
            on_click=lambda e: print('clicked!'),
        )
    buttons = ft.Row(
        controls=[
            sendOTP,
        ],
    )
    buttons.controls.append(
        log,
    )
    loginForm.controls.append(
        buttons,
    )
    settingsContainer.controls.append(
        loginForm,
    )
    return AppView(
        '/settings/dhiraagu',
        [
            ft.AppBar(
                leading=ft.IconButton(
                    ft.icons.ARROW_BACK_IOS_NEW_ROUNDED,
                    on_click=lambda _: page.go('/settings'),
                ),
                title=ft.Text(Title(str(__file__))),
                bgcolor=ft.colors.TRANSPARENT,
            ),
            settingsContainer,
        ],
    )
