import flet as ft
from utils import AppView, Title
from ..functions import config

ft.Control


def Settings(page: ft.Page):
    settingsContainer = ft.ListView(
        expand=True,
    )
    settingsContainer.controls.append(ft.Text('General'))

    def _on_enable_change(e: ft.ControlEvent):
        if config.getint('apps', 'mwsc'):
            config.save('apps', 'mwsc', '0')
        else:
            config.save('apps', 'mwsc', '1')
        page.update()

    generalSettings = ft.Container(
        content=ft.Column(
            controls=[
                ft.Card(
                    content=ft.Container(
                        content=ft.Container(
                            ft.Switch(
                                label='     Enable this module',
                                on_change=_on_enable_change,
                                value=False,
                            ),
                        ),
                        padding=10,
                        on_click=None,
                    ),
                ),
            ],
        ),
    )
    if config.getint('apps', 'mwsc') == 1:
        generalSettings.content.controls[0].content.content.content.value = True
    settingsContainer.controls.append(
        generalSettings,
    )
    return AppView(
        '/settings/mwsc',
        [
            ft.AppBar(
                leading=ft.IconButton(
                    ft.icons.ARROW_BACK_IOS_NEW_ROUNDED,
                    on_click=lambda _: page.go('/settings'),
                ),
                title=ft.Text(Title(str(__file__))),
                bgcolor=ft.colors.TRANSPARENT,
            ),
            settingsContainer,
        ],
    )
